*
* Program...: PICBASE.PRG
* Author(s).: John A. Fagerberg
* Date......: 09-04-1991
* Title.....: Photo Database Systems
* Purpose...: Maintain Photograph/Slide dBases
*
SET TALK OFF
SET HEAD OFF
SET SAFE OFF
SET STAT OFF
SET BELL OFF
SET SCOR OFF
*set esca off
set curs off
set proc to pic.prc
_peject="AFTER"
edcon=.t.
CLEA

defi menu main
  defi pad a of main prom "Batch" at 0,0;
      mess "Batch File"
  defi pad b of main prom "dBase" at 0,10;
      mess "dBase File"
  defi pad c of main prom "Print" at 0,20;
      mess "Print Labels"
  defi pad d of main prom "Exit" at 0,30
  on pad a of main acti popu batch_menu
  on pad b of main acti popu dbase_menu
  on pad c of main acti popu print_menu
  on pad d of main acti popu exit_pgm

defi popu batch_menu from 1,0
  defi bar 1 of batch_menu prom "Create a New Batch of photos"
  defi bar 2 of batch_menu prom "Edit Batch records"
  defi bar 3 of batch_menu prom "Print top labels only"
  defi bar 4 of batch_menu prom "Print top & bottom labels"
  defi bar 5 of batch_menu prom "Merge batch into dBase"
  on sele popu batch_menu do batch_proc

defi popu dbase_menu from 1,10
  defi bar 1 of dbase_menu prom "Edit dbase Records"
  defi bar 2 of dbase_menu prom "Print top labels only"
  on sele popu dbase_menu do dbase_proc

defi popu print_menu from 1,20
  defi bar 1 of print_menu prom "Print Top labels only-for batch"
  defi bar 2 of print_menu prom "Print Top & Bottom labels-for batch"
  defi bar 3 of print_menu prom "Print Top labels only-for dBase"
  on sele popu print_menu do print_proc

defi popu exit_pgm from 1,30
  defi bar 1 of exit_pgm prom "Exit"
  defi bar 2 of exit_pgm prom "Quit to DOS"
  on sele popu exit_pgm do exit_bytex

defi wind fscreen from 0,0 to 24,79 none color w/b

defi wind activity from 10,18 to 14,70 panel color r/w

defi wind errors from 10,18 to 14,70 panel color w/r

*Ŀ
*                                     
*     This is the Main Program        
*                                     
*
* on error do errormsg

  sele 1
  use MASSLIDE order tag MS_CN
  sele 2
  use N_BATCH
  sele 3
  use cameras order camera
  sele 4
  use lenses order len_make
  sele 5
  use film order film_code
  sele 1
  do main_menu
  on erro
  retu

proc main_menu
  acti menu main
  on erro
  retu

*Ŀ
*                                     
*     Close All and exit              
*                                     
*
proc exit_bytex      && "Exit" on main menu
  clea
  close all
  do case
    case bar()=1          && "Exit to dBase"
      set esca on
      set curs on
      set talk on
      deac menu
    case bar()=2          && "Exit to DOS"
      quit
  endc

*Ŀ
*                                     
*     Batch - Main Routine            
*                                     
*
proc batch_proc      && "create" on main menu

  do case
    case bar()=1          && "Create"
      do new_batch
    case bar()=2          && "Edit"
      acti wind fscreen
      set form to picbase
      sele 2
      go bott
      edit noap
      sele 1
      clos form
      deac wind fscreen
    case bar()=3          && "Print Top Label"
      do plabel1
    case bar()=4          && "Print Top & Bottom Label"
      do plabel2
    case bar()=5          && "Merge"
      do bmerge
  endc
  retu

*Ŀ
*                                     
*     Create New Batch                
*                                     
*
proc new_batch
SET CONF OFF
acti wind fscreen
SELE 1
DEFI POPU STUFF FROM 7,30
DEFI BAR 1 OF STUFF PROMPT "KODACHROME FILM"
DEFI BAR 2 OF STUFF PROMPT "EKTACHROME REGULAR"
DEFI BAR 3 OF STUFF PROMPT "EKTACHROME HC"
DEFI BAR 4 OF STUFF PROMPT "FUGICHROME FILM"
DEFI BAR 5 OF STUFF PROMPT "FUGI VELVIA"
DEFI BAR 6 OF STUFF PROMPT "AGFACHROME"
DEFI BAR 7 OF STUFF PROMPT "ENTER DIFFERENT FILM"
ON SELE POPU STUFF DO films
STOR SPAC (8) TO MDATE
STOR 1 TO N
STOR '       ' TO FCODE
STOR '     ' TO MS_CLASS
SET CURS ON
@ 3,5 SAY 'ENTER STOCK CLASS FOR NEW BATCH' GET MS_CLASS
READ
ms_class = upper(ms_class)
SET FILTER TO STOCKCLASS = MS_CLASS
GO BOTT
STOR MASTERNUMB +1 TO MS_NUMB
@ 5,5 SAY 'ENTER FIRST RECORD # FOR NEW BATCH'  GET MS_NUMB
READ
@ 7,5 SAY 'HOW MANY SLIDES DO YOU WANT TO CATALOG?' GET N
READ
SELE 2
ZAP
STORE N TO L
DO WHIL L > 0
  APPE BLANK
  L=L-1
ENDD
GO TOP
DO WHIL N >= 1
  REPL MASTERNUMB WITH MS_NUMB
  MS_NUMB=MS_NUMB+1
  N=N-1
  SKIP
ENDD
STOR DATE () TO MDATE
STOR chr(4)+SPAC (9) TO FCAM
stor chr(4)+spac (4) to fcode
stor chr(4)+spac (24) to flens
STOR SPAC (25) TO FTITLE
STOR SPAC (25) TO FMARK
STOR SPAC (8) TO FEXP
STOR .N. TO FMR
STOR .N. TO FPR
@ 9,5 SAY 'ENTER THE DATE OF SHOOT' GET MDATE
READ
CLEA
STOR 0 TO FSPEED
STORE .F. TO FLB
*@ 1,5 TO 23,70 DOUBLE
*@ 2,21 SAY 'FORMAT FOR ENTERING GLOBAL IMAGE DATA'
*@ 3,21 SAY ''
*@ 5,13 SAY 'ENTER ISO OF FILM USED:'
*@ 5,37 GET FSPEED
*@ 7,13 SAY 'ENTER THE CAMERA USED:' GET FCAM
*@ 9,13 SAY 'ENTER TITLE (IF DESIRED)' GET FTITLE
*@ 11,13 SAY 'ENTER ANY GLOBAL REMARK' GET FMARK
*@ 13,13 SAY 'ENTER EXPOSURE DATA' GET FEXP
*@ 15,13 SAY 'ENTER Y IF MODEL RELEASED' GET FMR
*@ 17,13 SAY 'ENTER Y IF PROPERTY RELEASED' GET FPR
*@ 19,13 SAY 'ENTER Y IF LABEL ALREADY PRINTED' GET FLB
*READ
SET CURS OFF
CLEA
*@ 5,30 SAY ' SELECT THE FILM USED:'
*ACTI POPU STUFF
GOTO TOP
REPL ALL STOCKCLASS WITH MS_CLASS
REPL ALL FILM_CODE WITH FCODE
REPL ALL DATE WITH MDATE
REPL ALL ISO WITH FSPEED
REPL ALL CAMERA WITH FCAM
repl all len_make with flens
REPL ALL TITLE WITH FTITLE
REPL ALL REMARKS WITH FMARK
REPL ALL EXPOSURE WITH FEXP
REPL ALL MODELREL WITH FMR
REPL ALL PROPREL WITH FPR
REPL ALL LABEL WITH FLB
GO TOP
SET FORM TO picbase
EDIT noap
CLOS FORM
deac wind fscreen
RETU

proc films
DO CASE
  CASE BAR () =1
    STOR 'KD' TO FCODE
  CASE BAR () =2
    STOR 'EK' TO FCODE
  CASE BAR () =3
    STOR 'EKHC' TO FCODE
  CASE BAR () =4
    STOR 'FG' TO FCODE
  CASE BAR () =5
    STOR 'FGV' TO FCODE
  CASE BAR () =6
    STOR 'AG' TO FCODE
  CASE BAR () =7
    CLEA
    @ 5,10 TO 12,65 DOUB
    @ 7,12 SAY "ENTER CODE OF FILM USED:"
    @ 7,35 GET FCODE
    READ
endc
deac popu
retu

*Ŀ
*                                     
*     Merge Batch into dBase          
*                                     
*
proc bmerge
acti wind activity
@1,1 say "*** Wait ***"
@2,1 say "Merging Batch into dBase"
SELE 2
USE
SELE 1
APPE FROM N_BATCH
SELE 2
USE N_BATCH
ZAP
SELE 1
deac wind activity
RETU

*Ŀ
*                                     
*     dBase - Main Routine            
*                                     
*
proc dbase_proc      && "dBase" from main menu

  do case
    case bar()=1          && "Edit dBase"
      acti wind fscreen
      stor '     ' to ms_class
      set curs on
      @3,5 say "ENTER STOCK CLASS TO EDIT" get ms_class
      read
      set curs off
      sele 1
      ms_class = upper(ms_class)
      set filter to stockclass=ms_class
      go bott
      clea
      set form to picbase
      edit noap
      clos form
      deac wind fscreen
    case bar()=2          && "Print Top & Bottom Labels"
      do plabel3
  endc
  retu

*Ŀ
*                                     
*     Print - Main Routine            
*                                     
*
proc print_proc      && "Print" from main menu

  do case
    case bar()=1          && "Print Top Labels only-for batch"
      do plabel1
    case bar()=2          && "Print Top & Bottom Labels-for batch"
      do plabel2
    case bar()=3          && "Print Top & Bottom Labels-for dBase"
      do plabel3
  endc
  retu

*Ŀ
*                                     
*     Print Top Label - Batch         
*                                     
*
proc plabel1
acti wind fscreen
SELE 2
DO PRINTL1
DO LABEND
deac wind fscreen
RETU


PROC PRINTL1
GO TOP
@ 8,5  SAY ' IF PRINTER IS READY, HIT RETURN'
WAIT
CLEA
SET FILT TO .NOT. LABEL
labe form picbase1 samp to prin
RETU

PROC LABEND
DO LABRES
STOR 'Y' TO YN
WAIT "ARE YOU READY TO MOVE YOUR BATCH FILE TO THE MASTER FILE (Y/N)?" TO YN
IF UPPE (YN) = "Y"
  DO bmerge
ENDI
RETU

PROC LABRES
STOR 'Y' TO YN
CLEA
@ 8,5 SAY "CHECK YOU LABELS"
?
WAIT  "ARE YOU READY TO RESET YOUR LABEL PRINTED FLAGS (Y/N)?" TO YN
IF UPPE (YN) = "Y"
  CLEA
  REPL ALL LABEL WITH .T.
ELSE
  CLEA
  RETU
ENDI
SELE 1
RETU

*Ŀ
*                                     
*    Print Top & Bottom Label - Batch 
*                                     
*
proc plabel2
acti wind fscreen
SELE 2
DO PRINTL1
GO TOP
labe form picbase2 to prin
DO LABEND
deac wind fscreen
RETU


*Ŀ
*                                     
*    Print Top Label - dBase          
*                                     
*
proc plabel3
acti wind fscreen
SELE 1
DO PRINTL1
DO LABRES
deac wind fscreen
RETU

*Ŀ
*                                     
*     dBase Maint.                    
*                                     
*


proc leadsmtn        && "dBase Maintenance" from leads menu
  acti popu leads_mtn

proc lead_mtn
  DO CASE
    CASE bar()=1          && "Clean Out Blank Records" from leads maint menu
      acti wind activity
      SELE 1
      @1,1 say "Please Wait while Leads being cleaned"
      GO TOP
      DELE FOR ADDRESS1 = SPACE(35)
      PACK
      SELE 2
      @1,1 say "Please Wait while Leadscon being cleaned"
      GO TOP
      DELE FOR ADDRESS1 = SPACE(35)
      PACK
      SELE 1
      deac wind activity
    CASE bar()=2          && "Reindex dBases" from leads maint menu
      acti wind activity
      @1,1 say "Please wait while Dbases being reindexed"
      SELE 1
      REIN
      SELE 2
      REIN
      deac wind activity
    CASE bar()=5          && "Return to Leads" from leads maint menu
      deac popu
  ENDC


proc ffilter
  priv ix,iy,ffilter
  acti wind fscreen
  set colo to w/b,b/w
  clea
  copy stru exte to ffwrk
  sele 3
  use ffwrk
  @1,0 to 23,79 double
  @3,2 say "Menu FF.0001"
  @3,34 say "Specify Filter"
  @5,1 to 5,78
  stor 8 to ix
  stor 3 to iy
  do whil iy < 78
    do whil ix < 22
      if .not. eof()
        @ix,iy say field_name+' '+field_type+' '+str(field_len,2)
        skip
      else
        ix=22
        iy=78
      endi
      ix=ix+1
    endd
    ix=8
    iy=iy+20
  endd
  use
  sele 1
  delete file ffwrk.dbf
  stor 1 to ffok
  set curs on
  do whil ffok=1
    stor space(76) to ffilter
    @6,2 get ffilter
    read
    ffok=0
    on error do ffiltere
    set filter to &ffilter
    on error do errormsg
  endd
  set curs off
  deac wind fscreen
  retu

proc ffiltere
*                   Use ON ERROR DO FILTERE to enable
  set colo to r/w
  @23,10 say "Filter in Error"
  set colo to w/b
  ffok=1
  retu

proc prom
para loc, msg, key
*                   Prompt for one char response
  priv ik
  clear type
  ik = 0
  @ &loc say msg
  do whil ik=0
      ik=inkey()
  endd
  key = chr(ik)
  retu

proc errormsg
*                   Use ON ERROR DO ERRORMSG to enable
  acti wind errors
  @1,1 say mess()
  do case
     case error()=114
        clear
        @ 2,1 say "The INDEX file is damaged, "+;
           "I am REINDEXing"
        rein
        wait
        deac wind errors
        retr
     case error()=125
        @ 2,1 say "Please turn the PRINTER ON"
        wait
        deac wind errors
        retr
     case error()=126
        @ 2,1 say "Please turn the PRINTER ON"
        wait
        deac wind errors
        retr
     othe
        @ 2,1 say "I've encountered an error = "+str(error(),3)+;
           " Module "+program()+" line "+str(lineno())+" Please try again"
        wait
        deac wind errors
        clos all
        on escape
        retu to master
  endc

proc prtpause
*                   Use ON KEY DO PTRPAUSE to enable
  priv ik
  set devi to scre
  acti wind activity
  @ 1,1 say '*** Printout Stopped ***'
  @ 2,1 say 'Do you want to abort this printout? (Y or N)'
  ik = 0
  do whil ik=0
      ik=inkey()
  endd
  bytkey=chr(ik)
  if upper(bytkey)='Y'
    deac wind activity
    retry
  endif
  deac wind activity
  set devi to prin
  retu

